
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <string.h>
#include <signal.h>
//#include "../include/adsdio.h"
#include "../include/apaxLocalIo/adsdio.h"

int main ( int argv, char **arg )
{
	LONG lHandle = 0, lRet;
	DWORD dwID, dwVer;
	struct SlotInfo stSlotInfo = {0};
	int i;
	
	if (ERR_SUCCESS == ADAMDrvOpen(&lHandle))
	{
		printf("ADAMDrvOpen done\n");
		// get library version
		if (ERR_SUCCESS == SYS_GetVersion(lHandle, &dwVer))
			printf("Library version = %X\n", dwVer);
		else
			printf("SYS_GetVersion failed\n");

		// scan modules
		printf("Scan modules from Slot 0~31\n\n");
		for (i = 0; i < 32; i++)
		{
			if (ERR_SUCCESS == (lRet = SYS_GetModuleID(lHandle, i, &dwID)))
			{
				printf("===============================\n");
				printf("Module ID[%d]  = %X\n", i, dwID);
				if (ERR_SUCCESS == (lRet = SYS_GetSlotInfo(lHandle, i, &stSlotInfo)))
				{
					printf("Slot ID        = %d\n", i);
					printf("Module ID      = %X\n", stSlotInfo.dwModName);
					printf("Hardware Ver   = %X\n", stSlotInfo.wHwVer);
					printf("Firmware Ver   = %X\n", stSlotInfo.wFwVerNo);
					printf("Firmware Build = %X\n", stSlotInfo.byFwVerBld);
					printf("===============================\n");
				}
				else
					printf("SYS_GetSlotInfo[%d]  err = %d\n", i, lRet);
			}
			else
				printf("SYS_GetModuleID[%d]  err = %d\n", i, lRet);
		}
		
/*		
		if (ERR_SUCCESS == (lRet = SYS_SetLocateModule(lHandle, 6, 30000)))
			printf("SYS_SetLocateModule: %f\n", lRet);
		else
			printf("SYS_SetLocateModule failed, %f\n", lRet);

		//for APAX-5018
		if (ERR_SUCCESS == (lRet = AI_GetCjcValue(lHandle, 3, &dwRet, &status)))
			printf("AI_GetCjcValue: %X, status: %X\n", dwRet, status);
		else
			printf("AI_GetCjcValue failed, %f\n", lRet);
*/
		ADAMDrvClose(&lHandle);

		return 0;
	}else
		printf("ADAMDrvOpen failed\n");
	return 1;
}

 
