/* #############################################################################
   *****************************************************************************
                  Copyright (c) 2011, Advantech eAutomation Division
                               Advantech Co., Ltd.
                               APAX Linux IO Driver
        THIS IS AN UNPUBLISHED WORK CONTAINING CONFIDENTIAL AND PROPRIETARY
           INFORMATION WHICH IS THE PROPERTY OF ADVANTECH AUTOMATION CORP.
           
      ANY DISCLOSURE, USE, OR REPRODUCTION, WITHOUT WRITTEN AUTHORIZATION FROM
                 ADVANTECH AUTOMATION CORP., IS STRICTLY PROHIBITED.
   *****************************************************************************
   #############################################################################
   
   File:        advadsdioglobal.h
   Description: This is the internal definitions and functions header for APAX Linux IO Driver
   Status:      works
   Author:		Tony Liu
   Change log:	Version 1.00 <2011/4/6>
	 				      - Initial version 
                Version 1.01 <2015/11/24>
	 				      - Add DPM_CommMsgSetSampleRate, DPM_CommMsgGetSampleRate, DPM_CommMsgGetChannelMask
                          
  ----------------------------------------------------------------------------
   Permission to use, copy, modify, and distribute this software and its
   documentation for any purpose and without fee is hereby granted, provided
   that the above copyright notice appear in all copies and that both that
   copyright notice and this permission notice appear in supporting
   documentation.  This software is provided "as is" without express or
   implied warranty.
  ----------------------------------------------------------------------------*/
#include "apaxtype.h"

#ifndef __ADVADSDIOGLOBAL_H__
#define __ADVADSDIOGLOBAL_H__

// status
#define SlotHasModule					0x01
#define SlotEmpty						0xFF
#define MaxCNTCh						8
#define MaxCNTChPG						6
#define MaxCNTGate						4
#define MaxAIOCh						32
#define MaxDIOCh						64		//32
#define MaxSlot							32		//16
#define MaxCommLen						1600	//1200
#define MaxFirmLen						600

#define MiddleSlot						16
#define MiddleDIOCh						32
// define DSP->KW section
#define DPM_ULSlotErrOffset				12
#define DPM_ULSlotDataStart				24
#define DPM_ULDataSizeOfSlot			336		//132
#define DPM_ULModuleIDOffset			0
#define DPM_ULSlotStatusOffset			4
#define DPM_ULChStatusOffset			8
#define DPM_ULExtFlagOffset				40
#define DPM_ULRegMaskOffset				44
#define DPM_ULExtRegMaskOffset			48
#define DPM_ULAllChangedFlagOffset		60		//48
#define DPM_ULDataOffset				64		//52
#define DPM_ULExtDataOffset				128		//116

#define DPM_ULSlot16Start				5400
#define DPM_ULSlot16ModuleIDOffset		0
#define DPM_ULSlot16SlotStatusOffset	4
#define DPM_ULSlot16DataOffset			8
#define DPM_ULSlot16Size				16

// define KW->DSP section
#define DPM_DLDataStartHigh				5696
#define DPM_DLDataStartLow				5700	//5496	//2232
#define DPM_DLCmdFlagOffset				4
#define DPM_DLAckFlagOffset				8
#define DPM_DLSlotDataStart				5712	//5508	//2244
#define DPM_DLDataSizeOfSlot			276		//72
#define DPM_DLRegMaskOffset				0
#define DPM_DLExtRegMaskOffset			4
#define DPM_DLTotalBytesOffset			16		//4
#define DPM_DLDataStartAddrOffset		20		//8
#define DPM_DLExtDataStartAddrOffset	84

#define DPM_DLSlot16Start				10128
#define DPM_DLSlot16DataOffset			4
#define DPM_DLSlot16Size				12
#define DPM_DLGlaMutex					10988	// 2010/10/22,
// define communication channel download
#define DPM_CommGlaMutex				10992	//3496
#define DPM_CommDLDspChannelFlag		10996	//3496
#define DPM_CommDLDataStart				11000	//3500
#define DPM_CommDLCmdFlagOffset			4
#define DPM_CommDLAckFlagOffset			8
#define DPM_CommDLPacketStart			11012	//3512
#define DPM_CommDLPacketLenOffset		0
#define DPM_CommDLPacketDataOffset		8

// define communication channel upload
#define DPM_CommULDataStart				12620	//4720
#define DPM_CommULCmdFlagOffset			4
#define DPM_CommULAckFlagOffset			8
#define DPM_CommULPacketStart			12632	//4732
#define DPM_CommULPacketLenOffset		0
#define DPM_CommULPacketDataOffset		8

// define Heartbeat and Alarm function
#define DPM_HeartbDataStart			16340
#define DPM_HeartbSetAppAOffset		4
#define DPM_HeartbGetAppBOffset		8
#define DPM_HeartbSetAppBOffset		12
#define DPM_HeartbGetAppAOffset		16
#define DPM_HeartbSetGlobalOffset	20
#define DPM_HeartbGetGlobalOffset	24
#define DPM_HeartbGetMachIDOffset	28
#define DPM_HeartbGetActiveOffset	32

// define command code
#define DPM_CommMsgGetSlotInfo			0x0004
#define DPM_CommMsgSetConfigMain		0x000A
#define DPM_CommMsgSetDownloadStart		0x001A
#define DPM_CommMsgSetDownloadPacket	0x001C
#define DPM_CommMsgSetZeroCalibration	0x0024
#define DPM_CommMsgSetSpanCalibration	0x0026
#define DPM_CommMsgSetAutoCalibration	0x0028
#define DPM_CommMsgSetDownloadMode		0x002E
#define DPM_CommMsgSetCalibrationMode	0x0032
#define DPM_CommMsgSetDiFilter			0x0034
#define DPM_CommMsgSetActPeriod			0x0036
#define DPM_CommMsgSetRangeCode			0x0038
#define DPM_CommMsgSetChannelMask		0x003A
#define DPM_CommMsgSetIntegrationTime	0x003C
#define DPM_CommMsgSetStartupValue		0x003E
#define DPM_CommMsgGetStartupValue		0x0040
#define DPM_CommMsgGetDiFilter			0x0044	//2008/12/23 Tim.Lin add
#define DPM_CommMsgSetAlarmConfig		0x0048	//2009/03/04
#define DPM_CommMsgGetAlarmConfig		0x004A	//2009/03/04
#define DPM_CommMsgSetClearAlarm		0x004C	//2009/03/04
#define DPM_CommMsgSetClearOverflow		0x004E	//2009/03/04
#define DPM_CommMsgSetClearCounter		0x0050	//2009/03/04
#define DPM_CommMsgSetGateConfig		0x0052	//2009/03/04
#define DPM_CommMsgGetGateConfig		0x0054	//2009/03/04
#define DPM_CommMsgSetChannelValOffset	0x0056	//2009/03/02
#define DPM_CommMsgGetChannelValOffset	0x0058	//2009/03/02
#define DPM_CommMsgGetCjcValue			0x005A	//2009/03/02
#define DPM_CommMsgSetCounterConfig		0x005E	//2009/03/24
#define DPM_CommMsgGetCounterConfig		0x0060	//2009/03/24

#define DPM_CommMsgSetAiConfig			0x006E	//2009/09/23
#define DPM_CommMsgGetAiConfig			0x0070	//2009/09/23
#define DPM_CommMsgSetCntFunConfig		0x0072	//2009/09/23
#define DPM_CommMsgGetCntFunConfig		0x0074	//2009/09/23
#define DPM_CommMsgSetCntFunStatus		0x0078	//2009/09/23
#define DPM_CommMsgGetCntFunStatus		0x0076	//2009/09/23
#define DPM_CommMsgClearWDT		        0x007A	//2009/10/21

#define DPM_CommMsgSetBurnoutFunEnable	0x0080	//2009/10/08
#define DPM_CommMsgGetBurnoutFunEnable	0x0090	//2009/10/08
#define DPM_CommMsgSetCjcInitValRecord	0x0084	//2009/10/08
#define DPM_CommMsgSetThermoCalibration	0x0086	//2009/10/08
#define DPM_CommMsgSetBurnoutValue		0x0082	//2009/10/08
#define DPM_CommMsgGetBurnoutValue		0x0088	//2009/10/08

#define DPM_CommMsgSetCustomIndex		0x008A	//2009/11/19
#define DPM_CommMsgGetCustomIndex		0x008C	//2009/11/19
#define DPM_CommMsgGetSaftyValue		0x0092	//2009/11/19
#define DPM_CommMsgSetSaftyValue		0x0094	//2009/11/19
#define DPM_CommMsgGetSaftyConfig		0x0096	//2009/11/19
#define DPM_CommMsgSetSaftyConfig		0x0098	//2009/11/19
#define DPM_CommMsgSetLocateModule		0x009A	//2009/11/19

#define DPM_CommMsgSetSampleRate     0x00AF	  //2015/11/24: add by Robert.Yin
#define DPM_CommMsgGetSampleRate     0x00B1  //2015/11/24: add by Robert.Yin
#define DPM_CommMsgGetChannelMask    0x00A9  //2015/11/24: add by Robert.Yin

#define DPM_CommMsgSetDownloadImageRecovery		0x0046 //2017/01/20, Yaojen+
#define DPM_CommMsgSetToDefault			          0x005C //2017/01/20, Yaojen+
#define DPM_CommMsgSetFACCalibration	        0x0064 //2017/01/20, Yaojen+
#define DPM_CommMsgGetResponseSelfDiagResult	0x0063 //2017/01/20, Yaojen+


#define	HTYPE_NONE		0
#define	HTYPE_DI		1
#define	HTYPE_DO		2
#define	HTYPE_AI		3
#define	HTYPE_AO		4
#define	HTYPE_CNT		5
#define	HTYPE_MOT		6

#pragma pack(push) /* push current alignment to stack */
#pragma pack(1)

typedef struct tagCMD_HEADER
{
	BYTE	byUID;
	WORD	wSeqNo;
	WORD	wPktVer;
	WORD	wMsgType;
} CMD_HEADER;

typedef struct tagCMD_GENERAL
{
	CMD_HEADER	struHeader;
	DWORD		dwParam_0;
	DWORD		dwParam_1;
	DWORD		dwParam_2;
	DWORD		dwParam_3;
	DWORD		dwParam_4;
} CMD_GENERAL;

typedef struct tagCMD_VALUE
{
	CMD_HEADER	struHeader;
	WORD	wValues[MaxAIOCh];
} CMD_VALUE;

typedef struct tagCMD_DWVALUE16 
{
	CMD_HEADER	struHeader;
	DWORD	dwValues[16];
} CMD_DWVALUE16;

typedef struct tagCMD_DWVALUE 
{
	CMD_HEADER	struHeader;
	DWORD	dwValues[10];
} CMD_DWVALUE;

typedef struct tagCMD_FIRMWARE
{
	CMD_HEADER	struHeader;
	WORD	wPktSeq;
	WORD	wDataLen;
	BYTE	wData[MaxFirmLen];
} CMD_FIRMWARE;

typedef struct tagGENERAL_RESPONSE
{
	CMD_HEADER	struHeader;
	BYTE	bySrcUID;
	WORD	wCode;
} GENERAL_RESPONSE;

typedef struct tagSLOT_IOINFO
{
	BYTE	bySlotExist;
	BYTE	byReserved;
	BYTE	byDiBase;
	BYTE	byDiTotal;
	BYTE	byDoBase;
	BYTE	byDoTotal;
	BYTE	byAiBase;
	BYTE	byAiTotal;
	BYTE	byAoBase;
	BYTE	byAoTotal;
	BYTE	byCntBase;
	BYTE	byCntTotal;
	BYTE	byMotBase;
	BYTE	byMotTotal;
} SLOT_IOINFO;
#pragma pack(pop) /* restore original alignment from stack */

#ifdef __cplusplus
extern "C"
{
#endif


#define ADS_API //__declspec(dllexport)// Method: SYS_SetDspChannelFlag
// action: Internal used. DO NOT call this function in your program.
LONG ADS_API SYS_SetDspChannelFlag(LONG handle, WORD i_wFlag);

// Method: SYS_GetDspChannelFlag
// action: Internal used. DO NOT call this function in your program.
LONG ADS_API SYS_GetDspChannelFlag(LONG handle, WORD* o_wFlag);

// Method: SYS_SetDownloadMode
// action: Internal used. DO NOT call this function in your program.
LONG ADS_API SYS_SetDownloadMode(LONG handle, WORD i_wSlot);

// Method: SYS_SetDownloadStart
// action: Internal used. DO NOT call this function in your program.
LONG ADS_API SYS_SetDownloadStart(LONG handle, WORD i_wSlot);

// Method: SYS_SetDownloadPacket
// action: Internal used. DO NOT call this function in your program.
LONG ADS_API SYS_SetDownloadPacket(LONG handle, WORD i_wSlot, WORD i_wSequence, WORD i_wDataLen, BYTE* i_byData);

// Method: SYS_GetRawData
// action: Internal used. DO NOT call this function in your program.
LONG ADS_API SYS_GetRawData(LONG handle, DWORD i_dwStart, DWORD i_dwLength, BYTE* o_dwRawData);

// Method: SYS_SetRawData
// action: Internal used. DO NOT call this function in your program.
LONG ADS_API SYS_SetRawData(LONG handle, DWORD i_dwStart, DWORD i_dwLength, BYTE* i_dwRawData);

// Method: SYS_SetActMsgPeriod
// action: Internal used. DO NOT call this function in your program.
LONG ADS_API SYS_SetActMsgPeriod(LONG handle, WORD i_wSlot, DWORD i_dwPeriod);

// Method: SYS_SetCommLock
// action: Internal used. DO NOT call this function in your program.
LONG ADS_API SYS_SetCommLock(LONG handle, WORD i_wLock);

// Method: SYS_SetOutputLock
// action: Internal used. DO NOT call this function in your program.
LONG ADS_API SYS_SetOutputLock(LONG handle, WORD i_wLock);

// Method: SYS_SetCmdWriteRead
// action: Internal used. DO NOT call this function in your program.
LONG ADS_API SYS_SetCmdWriteRead(LONG handle, WORD i_wSlot, WORD i_wMsgType, 
								 DWORD i_dwPara1, DWORD i_dwPara2, DWORD i_dwPara3, DWORD i_dwPara4, DWORD i_dwPara5);

// Method: SYS_GetAllSlotErrorFlag
// action: Get the module status of the all slots.
// pre   : handle = driver handler
//         o_wError = the variable to hold all slots status.
// post  : If geting error flag succeeded, function returns ERR_SUCCESS,
//         and the o_wError contains slots status. From LSB to MSB of the value indicate
//         the slot-0 to slot-31 status. If the bit is 1, it means that the slot has no module present.
//         Otherwise, function returns error code.
//         If the error code is ERR_INTERNAL_FAILED, call GetLastError to get extended error information.
LONG ADS_API SYS_GetAllSlotErrorFlag(LONG handle, DWORD* o_wError);

// Method: SYS_RefreshIoInfo
// action: Internal used. DO NOT call this function in your program.
LONG ADS_API SYS_RefreshIoInfo(LONG handle);

// Method: SYS_SetHeartbeatRun
// action: Internal used. DO NOT call this function in your program.
LONG ADS_API SYS_SetHeartbeatRun(LONG handle, BOOL i_bRun);

// Method: SYS_GetHeartbeatRun
// action: Internal used. DO NOT call this function in your program.
LONG ADS_API SYS_GetHeartbeatRun(LONG handle, BOOL* o_bRun);

// Method: SYS_SetAppAHeartbeat
// action: Internal used. DO NOT call this function in your program.
LONG ADS_API SYS_SetAppAHeartbeat(LONG handle);

// Method: SYS_GetAppAStatus
// action: Internal used. DO NOT call this function in your program.
LONG ADS_API SYS_GetAppAStatus(LONG handle, BOOL* o_bAlive);

// Method: SYS_SetAppBHeartbeat
// action: Internal used. DO NOT call this function in your program.
LONG ADS_API SYS_SetAppBHeartbeat(LONG handle);

// Method: SYS_GetAppBStatus
// action: Internal used. DO NOT call this function in your program.
LONG ADS_API SYS_GetAppBStatus(LONG handle, BOOL* o_bAlive);

// Method: SYS_SetGlobalHeartbeat
// action: Internal used. DO NOT call this function in your program.
LONG ADS_API SYS_SetGlobalHeartbeat(LONG handle);

// Method: SYS_GetGlobalStatus
// action: Internal used. DO NOT call this function in your program.
LONG ADS_API SYS_GetGlobalStatus(LONG handle, WORD* o_wStatus);

// Method: SYS_GetGlobalMachineID
// action: Internal used. DO NOT call this function in your program.
LONG ADS_API SYS_GetGlobalMachineID(LONG handle, WORD* o_wID);

// Method: SYS_GetGlobalActive
// action: Internal used. DO NOT call this function in your program.
LONG ADS_API SYS_GetGlobalActive(LONG handle, WORD* o_wActive);

// Method: SYS_GetFpgaVersion
// action: Internal used. DO NOT call this function in your program.
LONG ADS_API SYS_GetFpgaVersion(LONG handle, DWORD* o_dwVer);

// Method: CNT_ClearWDT
// action: Internal used. DO NOT call this function in your program.
LONG ADS_API CNT_ClearWDT(LONG handle, WORD i_wSlot);

// Method: AI_GetConfig
// action: Internal used. DO NOT call this function in your program.
LONG ADS_API AI_GetConfig(LONG handle, WORD i_wSlot, DWORD* o_dwHighMask, DWORD* o_dwLowMask);

// Method: AI_SetConfig
// action: Internal used. DO NOT call this function in your program.
LONG ADS_API AI_SetConfig(LONG handle, WORD i_wSlot, DWORD i_dwHighMask, DWORD i_dwLowMask);


LONG TOOL_SetCmdWriteReadBase(LONG handle, BYTE i_byUID, WORD i_wMsgType, WORD i_wLength, BYTE* i_byData);

LONG TOOL_SetCmdWriteReadRet(LONG handle, BYTE i_byUID, WORD i_wMsgType, DWORD i_dwParam0,
					 DWORD i_dwParam1, DWORD i_dwParam2, DWORD i_dwParam3, DWORD i_dwParam4);

LONG TOOL_SetCmdWrite5Read10(LONG handle, BYTE i_byUID, WORD i_wMsgType, 
							 DWORD* i_dwParam0To4, DWORD* o_dwParam0To9); // 2009/03/02

#ifdef __cplusplus
}
#endif

#endif
