/* #############################################################################
   *****************************************************************************
                  Copyright (c) 2011, Advantech eAutomation Division
                               Advantech Co., Ltd.
                               APAX Linux IO Driver
        THIS IS AN UNPUBLISHED WORK CONTAINING CONFIDENTIAL AND PROPRIETARY
           INFORMATION WHICH IS THE PROPERTY OF ADVANTECH AUTOMATION CORP.
           
      ANY DISCLOSURE, USE, OR REPRODUCTION, WITHOUT WRITTEN AUTHORIZATION FROM
                 ADVANTECH AUTOMATION CORP., IS STRICTLY PROHIBITED.
   *****************************************************************************
   #############################################################################
   
   File:        advadsdiolinux.h
   Description: This is the internal definitions header for APAX Linux IO Driver
   Status:      works
   Author:		Tony Liu
   Change log:	Version 1.00 <2011/4/6> Tony Liu
	 				- Initial version 
				Version 1.01 <2016/7/14> Robert Yin
				    - Merge Windows EBUS Library
	 				
  ----------------------------------------------------------------------------
   Permission to use, copy, modify, and distribute this software and its
   documentation for any purpose and without fee is hereby granted, provided
   that the above copyright notice appear in all copies and that both that
   copyright notice and this permission notice appear in supporting
   documentation.  This software is provided "as is" without express or
   implied warranty.
  ----------------------------------------------------------------------------*/
#include <linux/ioctl.h>
#include "apaxtype.h"

#ifndef __APAXLOCALIO_IOCTL_H__
#define __APAXLOCALIO_IOCTL_H__

//Command used by ioctl system call
#define APAXLOCALIO_IOC_MAGIC   'e'  // use 'd' as magic number

#define IOCTL_ADVADSDIO_GET_DUALPORT	_IO(APAXLOCALIO_IOC_MAGIC, 1)
#define IOCTL_ADVADSDIO_SET_DUALPORT	_IO(APAXLOCALIO_IOC_MAGIC, 2)
#define IOCTL_ADVADSDIO_SET_AO			_IO(APAXLOCALIO_IOC_MAGIC, 3)
#define IOCTL_ADVADSDIO_SET_DO			_IO(APAXLOCALIO_IOC_MAGIC, 4)
#define IOCTL_ADVADSDIO_GET_COMM		_IO(APAXLOCALIO_IOC_MAGIC, 5)
#define IOCTL_ADVADSDIO_SET_COMM		_IO(APAXLOCALIO_IOC_MAGIC, 6)
#define IOCTL_ADVADSDIO_SET_LOCK		_IO(APAXLOCALIO_IOC_MAGIC, 7)
#define IOCTL_ADVADSDIO_GET_IOPORT		_IO(APAXLOCALIO_IOC_MAGIC, 8)

//2016/7/14(Robert): Merge with windows EBUS Library//////////////////////
#define IOCTL_ADVADSDIO_GET_DIO _IO(APAXLOCALIO_IOC_MAGIC, 9)
#define IOCTL_ADVADSDIO_GET_AIO _IO(APAXLOCALIO_IOC_MAGIC, 10)
#define IOCTL_ADVADSDIO_SET_OUTPUTLOCK _IO(APAXLOCALIO_IOC_MAGIC, 11)
#define IOCTL_GET_MODULE_ID _IO(APAXLOCALIO_IOC_MAGIC, 12)

///!!!+++ Yaojen+ Jun 2017, for APAX-5017UH +++++++++++++
#define IOCTL_ADVADSDIO_GET_HS_PKT_BUF _IO(APAXLOCALIO_IOC_MAGIC, 13)

#define APAXLOCALIO_IOC_MAXNR   13 ///!!!12
///!!!---------------------------------------------------

//////////////////////////////////////////////////////////////////////////

#pragma pack(push) /* push current alignment to stack */
#pragma pack(1) /* set alignment to 1 byte boundary */

///!!!+++ Yaojen+ Nov 2016
typedef struct _SLOT_IOCMD_LOCK
{
    WORD	wSlot;
    DWORD	dwLockUnlock;
} SLOT_IOCMD_LOCK;

#define SLOT_IOCMD_LOCKED   1
#define SLOT_IOCMD_UNLOCKED 0
///!!!---

typedef struct _COMM_SETDATA
{
	WORD	wUID;
	WORD	wMsgType;
    DWORD	ulDataLen;
    DWORD	ulExpectLen;
} COMM_SETDATA;

typedef struct _DUALPORT_EXDATA
{
	DWORD	ulOffset;
    DWORD	ulDataLen;
} DUALPORT_EXDATA;

typedef struct _AO_SETDATA
{
	WORD	wFlush;
    WORD	wSlot;
    DWORD	dwMask;
    WORD	wValues[32];
} AO_SETDATA;

typedef struct _DO_SETDATA
{
	WORD	wFlush;
    WORD	wSlot;
    DWORD	dwHighValue;
    DWORD	dwLowValue;
} DO_SETDATA;

//2016/7/14(Robert): Merge with windows EBUS Library//////////////////////

typedef struct _AIO_GETDATA
{
    WORD	wSlot;
    DWORD	dwMask;
    WORD	wChanValues[32];
    UCHAR byChanStatus[32]; 
	  DWORD dwExtFlag; 
} AIO_GETDATA;


///!!!+++ Yaojen+ Jun 2017, for APAX-5017UH +++++++++++++
#define APAX_HS_PKT_QUEUE_SIZE    262144 //131072 //4096*32
#define APAX_HS_PKT_ENTRY_COUNT   8192  //4096 //near 5K pkts for 5KHz data in one second
#define APAX_HS_CHANNEL_COUNT     12

typedef struct _HSPacketBufferEntry
{
    unsigned short channel[APAX_HS_CHANNEL_COUNT];
    unsigned int   time_stamp_micro_sec;
    unsigned int   reserved;
} HSPacketBufferEntry;  

typedef struct _HSAI_GET_PKTBUF
{
    WORD	                wSlot;
    WORD	                wPktCnt;
    HSPacketBufferEntry   PktBuf[];
} HSAI_GET_PKTBUF;

typedef struct _HSChannelValueRow
{
    unsigned int time_stamp_micro_sec;
    float dRealValue[APAX_HS_CHANNEL_COUNT]; 	
}	HS_CHANNEL_VALUE_ROW;
///!!!---------------------------------------------------

typedef struct _DIO_GETDATA
{
    WORD	wSlot;
    DWORD	dwHighValue;
    DWORD	dwLowValue;
} DIO_GETDATA;

typedef struct _ID_EXDATA
{
	USHORT slot;
	DWORD moduleid;
	int order;
} ID_EXDATA, *PID_EXDATA;

//////////////////////////////////////////////////////////////////////////

#pragma pack(pop) /* restore original alignment from stack */

#endif // __APAXLOCALIO_IOCTL_H__
